﻿using D3StatsClient.Model;
using D3StatsClient.ViewModel;
using Elysium.Theme;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace D3StatsClient.Commands
{
    public class ChangeTheme : CommandBase
    {
        public override bool CanExecute(object parameter)
        {
            return true;
            
        }

        public override void Execute(object parameter)
        {
            ThemeType selectedTheme = (ThemeType)parameter;

            switch (selectedTheme)
            {
                case ThemeType.Dark:
                    ThemeManager.Instance.Dark(ThemeManager.Instance.Accent);
                    break;
                case ThemeType.Light:
                    ThemeManager.Instance.Light(ThemeManager.Instance.Accent);
                    break;
                default:
                    ThemeManager.Instance.Light(ThemeManager.Instance.Accent);
                    break;
            }

            //Add other windows which use listview here if needed.
            var vm = ViewModelManager<MainWindowViewModel>.ViewModel;
            var spvm = ViewModelManager<SessionPickerWindowViewModel>.ViewModel;

            //This is only to make sure we apply the custom styles to all listviews across viewmodels..
            //temporary hack
            if (vm != null)
            {
                vm.BackgroundColor = new System.Windows.Media.SolidColorBrush(ThemeManager.Instance.Background);
                vm.ForegroundColor = new System.Windows.Media.SolidColorBrush(ThemeManager.Instance.Foreground);
                vm.AccentColor = new System.Windows.Media.SolidColorBrush(ThemeManager.Instance.Accent);
            }

            if (spvm != null)
            {
                spvm.BackgroundColor = new System.Windows.Media.SolidColorBrush(ThemeManager.Instance.Background);
                spvm.ForegroundColor = new System.Windows.Media.SolidColorBrush(ThemeManager.Instance.Foreground);
                spvm.AccentColor = new System.Windows.Media.SolidColorBrush(ThemeManager.Instance.Accent);
            }
            
        }
    }
}
