﻿using D3StatsClient.D3MemoryAPI;
using D3StatsClient.Model;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;
using System.Windows.Media;

namespace D3StatsClient.Converters
{
    public sealed class ItemBackgroundColorConverter : IValueConverter
    {
        public ItemBackgroundColorConverter()
        {
            // set defaults
        }

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (!(value is string))
            {
                return null;
            }

            BrushConverter converter = new BrushConverter();

            ItemQuality qualityLevel = (ItemQuality)Enum.Parse(typeof(ItemQuality), value as string);

            FieldInfo fi = typeof(ItemQuality).GetField(value.ToString());
            ItemQualityColorAttribute[] attrs =
            fi.GetCustomAttributes(typeof(ItemQualityColorAttribute),
                                   false) as ItemQualityColorAttribute[];
            if (attrs.Length > 0)
            {
                //return ((SolidColorBrush)converter.ConvertFrom(attrs[0].Value)).Opacity = 0.5;
                Color brushcolor = (Color)ColorConverter.ConvertFromString(attrs[0].Value);

                SolidColorBrush scBrush = new SolidColorBrush(brushcolor);
                scBrush.Opacity = 0.3;

                return scBrush;

            }

            return Brushes.White;
        }

        public object ConvertBack(object value, Type targetType,
            object parameter, CultureInfo culture)
        {
            return value;
        }
    }
}
